package pallina;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;

import javax.swing.JComponent;

public class JBall extends JComponent implements Runnable {

	private boolean running = false;
	private int vx = 10, vy = 10;

	public JBall() {
		this.setPreferredSize(new Dimension(15, 15));
	}

	public boolean isRunning() {
		return running;
	}

	public void setRunning(boolean running) {
		this.running = running;
	}

	public int getVx() {
		return vx;
	}

	public void setVx(int vx) {
		if (Math.abs(vx) <= 10)
			this.vx = vx;
	}

	public int getVy() {
		return vy;
	}

	public void setVy(int vy) {
		if (Math.abs(vy) <= 10)
			this.vy = vy;
	}

	@Override	
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);

		int w = this.getWidth();
		int h = this.getHeight();

		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setColor(Color.BLUE);
		g2.fillOval(0, 0, w, h);
		g2.setColor(Color.BLACK);
		g2.drawOval(0, 0, w - 1, h - 1);
	}

	public void start() {
		if (!running) {
			running = true;
			Thread t = new Thread(this);
			t.setDaemon(true);
			t.start();
		}
	}

	public void stop() {
		running = false;
	}

	@Override
	public void run() {
		while (running) {
			int x = this.getX();
			int y = this.getY();
			x += vx;
			y += vy;
			Component contenitore = this.getParent();
			if (x < 0) {
				vx = Math.abs(vx);
				x += vx;
			}
			if (x > contenitore.getWidth() - this.getWidth()) {
				vx = -Math.abs(vx);
				x += vx;
			}
			if (y < 0) {
				vy = Math.abs(vy);
				y += vy;
			}
			if (y > contenitore.getHeight() - this.getHeight()) {
				vy = -Math.abs(vy);
				y += vy;
			}
			this.setLocation(x, y);
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
			}
		}

	}

}